// ------------------------ ПЕРЕМЕННЫЕ ------------------------
$drk: #202020;
$orng: #ff6e30;
$wht: #ffffff;
$lghtGrey: #999999;
$maxWidth: 1920;
$fontTT: "TTFirsNeue", sans-serif;
$fontRob: "Roboto", sans-serif;
$orngActv: #ce4307;
$orngFcs: #bc572b;

// ------------------------ ФУНКЦИИ ------------------------
@function vw($value, $screenWidth: $maxWidth) {
  @return #{$value / $screenWidth * 100}vw;
}

@function em($value) {
  @return #{$value / 16}em;
}

// ------------------------ МИКСИНЫ ------------------------
@mixin font-face($font-family, $url, $weight) {
  @font-face {
    font-family: "#{$font-family}";
    src: 
      // url("../fonts/#{$url}.woff2") format("woff2"),
      url("../fonts/#{$url}.woff") format("woff");
    font-weight: #{$weight};
    font-display: swap;
    font-style: normal;
  }
}

@mixin adaptiveValue(
  $property,
  $startValue,
  $newValue,
  $startWidth,
  $newWidth,
  $type
) {
  $addSize: $startValue - $newValue;
  @if $type==1 {
    #{$property}: $startValue + px;
    @media (max-width: #{$startWidth + px}) {
      #{$property}: calc(
        #{$newValue + px} + #{$addSize} *
          ((100vw - #{$newWidth + px}) / #{$startWidth - $newWidth})
      );
    }
  } @else if $type==2 {
    #{$property}: $startValue + px;
    @media (min-width: #{$startWidth + px}) {
      #{$property}: calc(
        #{$newValue + px} + #{$addSize} *
          ((100vw - #{$newWidth + px}) / #{$startWidth - $newWidth})
      );
    }
  } @else {
    #{$property}: calc(
      #{$newValue +
        px} +
        #{$addSize} *
        ((100vw - #{$newWidth + px}) / #{$startWidth - $newWidth})
    );
  }
}

// ------------------------ ИМПОРТЫ ------------------------
@import "0_header";
@import "1_works";
@import "2_about";
@import "3_projects";
@import "4_contacts";
@import "5_footer";

@import "fonts";
@import "normalize";

@keyframes showElem {
  0% {
    opacity: 0;
  }
  100% {
    opacity: 1;
  }
}

// ------------------------ ОБЩИЕ СТИЛИ ------------------------
*,
*::after,
*::before {
  margin: 0;
  padding: 0;
  box-sizing: border-box;
}

*:focus {
  outline: none;
}

body {
  color: $wht;
}

ul {
  list-style: none;
}

a,
button,
input {
  color: inherit;
  font-family: inherit;
}

a {
  text-decoration: none;
}

picture,
img,
svg {
  display: block;
}

svg {
  max-width: 100%;
}

img {
  height: auto;
  object-fit: cover;
}

button,
input {
  border: none;
  background: transparent;
}

button {
  cursor: pointer;
}

// ------------------------ ОБЩИЕ КЛАССЫ ------------------------
.visually-hidden {
  // position: absolute !important;
  clip: rect(1px 1px 1px 1px); /* IE6, IE7 */
  clip: rect(1px, 1px, 1px, 1px);
  padding: 0 !important;
  border: 0 !important;
  height: 1px !important;
  width: 1px !important;
  overflow: hidden;
}

.container {
  max-width: 1352px;
  margin: 0 auto;
  padding-right: 31px;
  padding-left: 31px;
}

.networks,
.menu {
  display: flex;
  flex-wrap: wrap;
}

.networks {
  &__item {
    &:not(:last-child) {
      margin-right: 20px;
    }
    .icon {
      fill: #cacaca;
      transition: fill 0.2s ease-in-out;
    }
    a:hover {
      .icon {
        fill: $orng;
      }
    }
    a:focus {
      .icon {
        fill: $orngFcs;
      }
    }
    a:active {
      .icon {
        fill: $orngActv;
      }
    }
  }
}

.menu {
  &__item:not(:last-child) {
    @include adaptiveValue("margin-right", 79, 33, 1920, 1024, 0);
  }
  &__link {
    line-height: 21px;
    color: $wht;
    transition: color 0.3s ease-in-out, background-color 0.3s ease-in-out;
    word-break: break-all;
    &:hover {
      color: $orng;
    }
    &:focus {
      background-color: $orngFcs;
      color: $wht;
    }
    &:active {
      background-color: transparent;
      color: $orngActv;
    }
  }
}

.title,
.caption,
.menu__link,
.header__tel,
.header__inp {
  font-family: $fontTT;
}

.title,
.caption {
  font-size: 24px;
}

.title,
.btn {
  font-weight: 700;
}

.title {
  line-height: 31px;
}

.caption,
.content,
.header__tel {
  line-height: 22px;
}

.parag,
.hashtag,
.btn,
.content,
.field,
.projects__tab {
  font-family: $fontRob;
}

.parag,
.content,
.btn,
.field,
.projects__tab,
.menu__link,
.header__tel {
  font-size: 16px;
}

.hashtag {
  position: absolute;
  background-color: #333333;
  font-size: 14px;
  line-height: 16px;
  padding: 6px 14px;
  text-align: center;
}

.parag {
  line-height: 28px;
}

.btn,
.field,
.projects__tab {
  line-height: 19px;
}

.logo {
  width: 190px;
  height: 31px;
}

.btn {
  text-align: center;
  transition: outline 0.2s ease-in-out, background-color 0.2s ease-in-out;
  outline-offset: -1px;
  outline: 3px solid $orng;
  padding: 16px 22px 15px;
  &_orange {
    align-self: flex-start;
    background-color: $orng;
    &:hover {
      background-color: $orngFcs;
      outline: 3px solid $orngFcs;
    }
    &:focus {
      background-color: $orng;
    }
    &:focus,
    &:active {
      outline: 3px solid $orngActv;
    }
    &:active {
      background-color: $orngActv;
    }
  }
  &__entire::after {
    content: "";
    position: absolute;
    display: block;
    top: 0;
    left: 0;
    bottom: 0;
    right: 0;
    width: 100%;
    height: 100%;
    z-index: 10;
  }
}

.field {
  padding: 15px 23px 16px;
  transition: color 0.2s ease-in-out, outline 0.2s ease-in-out;
  &::placeholder {
    transition: color 0.2s ease-in-out;
  }
  &:hover,
  &:hover::placeholder {
    color: $orng;
  }
  &:focus {
    outline: 1px solid $orng;
  }
  &_incorrect {
    &_incorrect {
      outline: 1px solid #f06666;
    }
  }
}

.date {
  display: flex;
  align-items: center;
  &__calendar,
  &__clocks {
    fill: $wht;
  }
  &__calendar {
    margin-right: 5px;
  }
  &__day {
    font-family: $fontRob;
    font-size: 12px;
    line-height: 22px;
  }
  &__clocks {
    margin-right: 4px;
  }
}

// ----------------------------- media 1024px ---------------------------------

@media (max-width: 1024px) {
  .container {
    @include adaptiveValue("padding-left", 31, 27, 1024, 768, 0);
    @include adaptiveValue("padding-right", 31, 27, 1024, 768, 0);
  }
  .menu {
    &__item:not(:last-child) {
      @include adaptiveValue("margin-right", 33, 10, 1024, 768, 0);
    }
  }
  .logo {
    width: 166px;
    height: 27px;
  }
}
// ----------------------------- media 768px ---------------------------------

@media (max-width: 768px) {
  .container {
    padding-left: 21px;
    padding-right: 20px;
    // @include adaptiveValue("padding-left", 27, 21, 768, 320, 0);
    // @include adaptiveValue("padding-right", 27, 21, 768, 320, 0);
  }
}

// ----------------------------- media 576px ---------------------------------

@media (max-width: 576px) {
  .btn,
  .parag,
  .field,
  .content {
    font-size: 14px;
  }
  .caption,
  .title {
    font-size: 18px;
  }
  .btn,
  .field {
    line-height: 16px;
  }
  .content {
    line-height: 18px;
  }
  .title {
    line-height: 23px;
  }
  .parag {
    line-height: 25px;
  }
  .hashtag,
  .projects__tab {
    font-size: 12px;
    line-height: 14px;
  }
  .hashtag {
    padding: 4px 14px;
    top: 5px;
    right: 5px;
  }
  .btn {
    padding: 12px 22px;
  }
  .logo {
    width: 112px;
    height: 18px;
  }
  .field {
    padding: 12px 23px 12px;
  }
}
